#<profile4xi profile = "11" /> 
# -------------------------------------------------------------------------------------------------
#<program4xi program = "fire2600four4xi.py">
#<abstract4xi abstract = "fires to direction four and to distance 2600"/>
#<verify4xi verification = "11" target = "verb4xi.py"/>
#<refer4xi reference = "verb4xi.py"/>
#<state4xi status = "ACK4tagging; ACK4moduletesting; NACK4systemtesting; [Rel 7.21]"/>
# -------------------------------------------------------------------------------------------------

# -------------------------------------------------------------------------------------------------
# Public API
# -------------------------------------------------------------------------------------------------
#<interface4xi interface = " 
__all__ = [ 'fire2600four4xi']
#"
#/>


# -------------------------------------------------------------------------------------------------
# Standard Imports                          
# -------------------------------------------------------------------------------------------------
#<standardize4xi standard = "
import os
import sys
import threading                
import _thread
import _winapi
   

import signal
import itertools
import weakref
import logging 

from math import pi
from math import sin
from math import cos 
from math import fabs
#"
#/>

# -------------------------------------------------------------------------------------------------
# DragonXi imports                              
# -------------------------------------------------------------------------------------------------
#<dragonize4xi dragonization = "


from time4xi import time4xi

#"
#/>

       
# -------------------------------------------------------------------------------------------------
# SHOT2FOUR - COORDINATE SIGNS OF SHOOT2FOUR4XI: (X + ,Y - ,Z + )
# -------------------------------------------------------------------------------------------------    
global shot2four26004xi


#"
#/>

# -------------------------------------------------------------------------------------------------
# Settings
# -------------------------------------------------------------------------------------------------
#<set4xi setting = "
ack2debug = False
shot2four26004xi = {
                1:'1005x-862y2236z',
                2:'1006x-187y2389z',
                3:'1032x-1355y1963z',
                4:'1038x-137y2379z',
                5:'1042x-2342y432z',
                6:'1060x-1747y1606z',
                7:'1067x-822y2223z',
                8:'1068x-84y2368z',
                9:'1094x-29y2358z',
                10:'1114x-1314y1946z',
                11:'1127x-778y2209z',
                12:'1159x-1703y1585z',
                13:'1165x-2288y407z',
                14:'1185x-729y2196z',
                15:'1195x-1268y1929z',
                16:'1240x-677y2182z',
                17:'1256x-1652y1565z',
                18:'1274x-1217y1911z',
                19:'1285x-2227y381z',
                20:'1294x-620y2167z',
                21:'132x-2523y610z',
                22:'1344x-560y2153z',
                23:'1350x-1161y1893z',
                24:'1351x-1596y1544z',
                25:'1392x-496y2138z',
                26:'1402x-2160y355z',
                27:'1424x-1101y1875z',
                28:'1437x-429y2123z',
                29:'1443x-1534y1523z',
                30:'1478x-358y2108z',
                31:'1495x-1035y1857z',
                32:'1515x-2086y329z',
                33:'1515x-284y2093z',
                34:'1532x-1467y1502z',
                35:'1548x-207y2077z',
                36:'154x-118y2592z',
                37:'1563x-965y1839z',
                38:'1578x-127y2062z',
                39:'1603x-45y2046z',
                40:'1618x-1395y1480z',
                41:'1625x-2006y304z',
                42:'1627x-891y1821z',
                43:'1688x-812y1802z',
                44:'1701x-1317y1459z',
                45:'1729x-1921y278z',
                46:'1745x-730y1783z',
                47:'176x-498y2545z',
                48:'1779x-1234y1437z',
                49:'1797x-643y1764z',
                50:'181x-124y2590z',
                51:'1829x-1829y252z',
                52:'1845x-553y1745z',
                53:'1854x-1147y1416z',
                54:'1889x-460y1725z',
                55:'1924x-1055y1394z',
                56:'1924x-1733y226z',
                57:'1927x-364y1706z',
                58:'1960x-265y1686z',
                59:'1988x-163y1666z',
                60:'1989x-959y1372z',
                61:'2011x-59y1646z',
                62:'2014x-1631y200z',
                63:'2049x-859y1349z',
                64:'2098x-1524y174z',
                65:'210x-128y2588z',
                66:'211x-512y2540z',
                67:'2176x-1413y148z',
                68:'2184x-784y1378z',
                69:'2249x-1298y122z',
                70:'2315x-1179y96z',
                71:'2374x-1057y70z',
                72:'239x-129y2585z',
                73:'2426x-931y44z',
                74:'2472x-803y18z',
                75:'249x-523y2534z',
                76:'264x-2519y585z',
                77:'269x-127y2582z',
                78:'288x-531y2528z',
                79:'299x-123y2579z',
                80:'329x-116y2576z',
                81:'329x-537y2522z',
                82:'360x-105y2572z',
                83:'371x-540y2516z',
                84:'390x-92y2568z',
                85:'397x-2507y560z',
                86:'414x-540y2509z',
                87:'419x-76y2564z',
                88:'425x-1034y2346z',
                89:'448x-58y2560z',
                90:'458x-536y2502z',
                91:'476x-36y2555z',
                92:'489x-1032y2335z',
                93:'502x-530y2495z',
                94:'503x-12y2550z',
                95:'529x-2488y534z',
                96:'547x-520y2487z',
                97:'553x-1025y2324z',
                98:'593x-507y2480z',
                99:'618x-1014y2312z',
                100:'638x-490y2472z',
                101:'659x-2462y509z',
                102:'683x-470y2464z',
                103:'684x-1000y2300z',
                104:'694x-1468y2030z',
                105:'728x-446y2455z',
                106:'749x-981y2288z',
                107:'772x-419y2446z',
                108:'779x-1448y2013z',
                109:'789x-2429y483z',
                110:'814x-958y2275z',
                111:'815x-389y2438z',
                112:'856x-355y2428z',
                113:'864x-1422y1997z',
                114:'879x-930y2262z',
                115:'897x-318y2419z',
                116:'917x-2389y458z',
                117:'935x-277y2409z',
                118:'943x-898y2250z',
                119:'949x-1391y1980z',
                120:'959x-1786y1626z',
                121:'972x-233y2399z'}
#"
#"/>
    

# -------------------------------------------------------------------------------------------------
#<function4xi function = "fire2600four4xi" usage = "target function for charge26004xi with Process4Xi">
#<state4xi status = "ACK4tagging; ACK4moduletesting; NACK4systemtesting"/>
# -------------------------------------------------------------------------------------------------
def fire2600four4xi(queue2four, consumer_channel2four, publisher_channel2four):
    '''
    returns (x,y,z) coordinates via queue
    '''
    
    # -------------------------------------------------------------------------------------------------
    # PARAMETERS                   
    # -------------------------------------------------------------------------------------------------                                                               
    
    time2start = time4xi()
    if ack2debug is True:
        print("\n (STEP 1A1/33) OF FIRE2600FOUR4XI - STARTED TIME: ", time2start)
        # 
        
        print("\n (STEP 1A2/33) OF FIRE2600FOUR4XI -  QUEUE2FOUR: ", queue2four)      
        # 
        
        print("\n (STEP 1A3/33) OF FIRE2600FOUR4XI -  CONSUMER_CHANNEL2FOUR: ", consumer_channel2four)
        # 
              
        print("\n (STEP 1A4/33) OF FIRE2600FOUR4XI -  PUBLISHER_CHANNEL2FOUR: ", publisher_channel2four)          
        # 
        


    # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
    # QUEUE RETURNING
    # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
    ack2put = False
    if ack2debug is True:
        print("\n (STEP 2A/33) OF FIRE2600FOUR4XI - TRYING TO RETURN BY PUTTING COORDINATE DICTIONARY TO QUEUE2FOUR: ", queue2four, " - TIME: ", time4xi()) 
        # 
         
    try:
        # ------------------------------------------------------------------------------------- 
        # PUT SHOT TO QUEUE 
        # -------------------------------------------------------------------------------------                 
        queue2four.put(shot2four26004xi)
        if ack2debug is True:
            print("\n (STEP 2B/33) OF FIRE2600FOUR4XI - SUCCEEDED TO PUT COORDINATE DICTIONARY TO QUEUE2FOUR: ", queue2four, " - TIME: ", time4xi()) 
            # 
             
        ack2put = True
    except:
        print("\n (STEP 2C/33) OF FIRE2600FOUR4XI *** FAILED TO PUT COORDINATE DICTIONARY TO QUEUE2FOUR: ", queue2four, " - TIME: ", time4xi()) 
    
    if ack2debug is True:
        print("\n (STEP 3A/33) OF FIRE2600FOUR4XI - TRYING TO INFORM PUT OPERATIONS VIA PIPE'S PUBLISHER_CHANNEL2FOUR: ", publisher_channel2four, " - TIME: ", time4xi())
        # 
         
    try:                
        # ---------------------------------------------------------------------------------------------
        # INFORM PUT OPERATIONS VIA PIPE'S PUBLISHER CHANNEL 
        # ---------------------------------------------------------------------------------------------
        if ack2put is True:
            message2send4one = "<ack2put4xi>queue2four8shot2four26004xi</ack2put4xi>"
        else:
            message2send4one = "<nack2put4xi>queue2four8shot2four26004xi</nack2put4xi>" 
            
        publisher_channel2four.send(message2send4one)
        if ack2debug is True:    
            print(" (STEP 3B/33) OF FIRE2600FOUR4XI -  SENT MESSAGE2SEND4ONE: ", message2send4one, " TO PUBLISHER_CHANNEL2FOUR: ", publisher_channel2four, " - TIME: ", time4xi()) 
            #  
        
    except:
        print(" (STEP 3C/33) OF FIRE2600FOUR4XI *** FAILED TO SEND MESSAGE2SEND4ONE: ", message2send4one, " TO PUBLISHER_CHANNEL2FOUR: ", publisher_channel2four, " - TIME: ", time4xi()) 
    
    if ack2debug is True:        
        print("\n (STEP 3D/33) OF FIRE2600FOUR4XI - RETURNING QUEUE OBJECT QUEUE2FOUR: ", queue2four, " - TIME: ", time4xi())  
        # 
            
    return queue2four    
        
           
#</function4xi>


#</program4xi>
# -------------------------------------------------------------------------------------------------
# Recorded History                             
# ------------------------------------------------------------------------------------------------- 
#<record4xi record = "
#   test_verb4xi.txt
#   sense-test-verb4xi.xml
#   reason-test-verb4xi.xml
#   ace-test-verb4xi.xml
#"
#>



# -------------------------------------------------------------------------------------------------
# Legal Notice                             
# ------------------------------------------------------------------------------------------------- 
#<protect4xi protection = "copyright"
#   owner = "Small & Smart"
#   rights = "All rights reserved"
#   state = "California"
#   country = "United States of America"
#   references = "Legal notice at www.dragonxi.com; www.yourdragonxi.com; www.yourdragonxi.org; www.dragon2xi.com/; www.dragon4xi.com/; www.dragon8xi.com/ " 
#   codes = "Codes established in California and applicable to corporations in California"
#   compliance = "The California Law"
#   court = "Supreme Court of California, 350 McAllister Street, San Francisco, CA 94102-4783"
#/>
 

#<end4xi end = "
# -------------------------------------------------------------------------------------------------
# end of fire2600four4xi.py                             
# ------------------------------------------------------------------------------------------------- 
#"
#/>
                                    